<?php

class TroubleTickets_AideChapitre {
	
	//Variables
	var $xml; /* Objet SimpleXMLElement utilis dans les fonctions */
	var $niveau; /* 1, 2 ou 3 */
	var $nomchapitreparentniveau1; /* renseign si le chapitre est de niveau 2 ou 3 */
	var $nomchapitreparentniveau2; /* renseign si le chapitre est de niveau 3 */
	var $nom;
	var $langue; /* fr ou en */
	
	//Constructeur
	function __construct($xml, $niveau=1, $nomchapitreparentniveau1='', $nomchapitreparentniveau2='', $nom='', $langue='fr') {
		$this->xml = $xml;
		$this->niveau = $niveau;
		$this->nomchapitreparentniveau1 = $nomchapitreparentniveau1;
		$this->nomchapitreparentniveau2 = $nomchapitreparentniveau2;
		$this->nom = $nom;
		$this->langue = $langue;
	}
	
	/* Retourne la liste des sous chapitres en objets TroubleTickets_AideChapitre */
	function souschapitres() {
		$chapitres = array();
		if ($this->niveau == 1) {
			if ($this->xml !== false) {
	    		if (isset($this->xml->chapitresniveau2)) {
	    			foreach ($this->xml->chapitresniveau2->chapitreniveau2 as $chapitre) {
	    				if (isset($chapitre->titre)) {
	    					if ($this->langue == 'fr') {
		    					if (isset($chapitre->titre->fr)) {
		    						$chapitres[] = new TroubleTickets_AideChapitre($chapitre, 2, $this->nom, '', utf8_decode($chapitre->titre->fr), 'fr');
		    					}
	    					}
	    					if ($this->langue == 'en') {
		    					if (isset($chapitre->titre->en)) {
		    						$chapitres[] = new TroubleTickets_AideChapitre($chapitre, 2, $this->nom, '', utf8_decode($chapitre->titre->en), 'en');
		    					}
	    					}
	    				}
	    			}
	    		}
			}
		}
		if ($this->niveau == 2) {
			if ($this->xml !== false) {
	    		if (isset($this->xml->chapitresniveau3)) {
	    			foreach ($this->xml->chapitresniveau3->chapitreniveau3 as $chapitre) {
	    				if (isset($chapitre->titre)) {
	    					if ($this->langue == 'fr') {
		    					if (isset($chapitre->titre->fr)) {
		    						$chapitres[] = new TroubleTickets_AideChapitre($chapitre, 3, $this->nomchapitreparentniveau1, $this->nom, utf8_decode($chapitre->titre->fr), 'fr');
		    					}
	    					}
	    					if ($this->langue == 'en') {
		    					if (isset($chapitre->titre->en)) {
		    						$chapitres[] = new TroubleTickets_AideChapitre($chapitre, 3, $this->nomchapitreparentniveau1, $this->nom, utf8_decode($chapitre->titre->en), 'en');
		    					}
	    					}
	    				}
	    			}
	    		}
			}
		}
		return $chapitres;
	}
	
	/* Retourne la liste des articles en objets TroubleTickets_AideArticle */
	function articles() {
		$articles = array();
		if (count($this->souschapitres()) == 0) {
			if ($this->xml !== false) {
	    		if (isset($this->xml->articles)) {
	    			foreach ($this->xml->articles->article as $article) {
	    				if (isset($article->titre)) {
	    					if ($this->langue == 'fr') {
		    					if (isset($article->titre->fr) && isset($article->texte->fr)) {
		    						$articles[] = new TroubleTickets_AideArticle($article, $this->nom, $this->niveau, utf8_decode($article->titre->fr), utf8_decode($article->texte->fr), 'fr');
		    					}
	    					}
	    					if ($this->langue == 'en') {
		    					if (isset($article->titre->en) && isset($article->texte->en)) {
		    						$articles[] = new TroubleTickets_AideArticle($article, $this->nom, $this->niveau, utf8_decode($article->titre->en), utf8_decode($article->texte->en), 'en');
		    					}
	    					}
	    				}
	    			}
	    		}
			}
		}
		return $articles;
	}
	
}

?>
