<?php

/* L'annuaire est utilis dans 3 situations :
   Annuaire en consultation
   Slection d'un auteur pour la cration d'un ticket (le projet peut-tre prcis)
   Slection des destinataires pour l'envoi d'un mail lors d'un change, de la modification de la vie du ticket... */
class TroubleTickets_Annuaire {
	
	//Variables : correspondent aux paramtres utiles  l'affichage de l'annuaire
	var $modeaffichage; /* annuaire, selectionauteurticket, selectiondestinatairesmail */
	var $typenotification; /* utile pour le type selectiondestinatairesmail : echange, historique, creation */
	var $idprojet; /* optionnel, utile pour le type selectionauteurticket */
	var $idticket; /* utile pour le type selectiondestinatairesmail */
	var $idclient; /* peut tre utilis  chaque fois pour filtrer et n'avoir que les interlocuteurs clients */
	var $lettre; /* optionnel */
	var $destinataires; /* utile pour le type selectiondestinatairesmail : liste des adresses mails spares par des virgules, espaces ou points virgules */
	var $destinatairesencopie;
	var $destinatairesencopiecachee;
	var $recherche; /* valeur fournie par le formulaire de recherche */
	
	//Constructeur
	function __construct($modeaffichage, $typenotification='', $idprojet='', $idticket='', $idclient='', $lettre='', $destinataires='', $destinatairesencopie='', $destinatairesencopiecachee='', $recherche='') {
		$this->modeaffichage = $modeaffichage;
		$this->typenotification = $typenotification;
		$this->idprojet = $idprojet;
		$this->idticket = $idticket;
		$this->idclient = $idclient;
		$this->lettre = $lettre;
		if ($this->lettre == 'toutes') {
			$this->lettre = '';
		}
		/* Destinataires renvoys lorsqu'on slectionne des destinataires pour un mail */
		$this->destinataires = $destinataires;
		$this->destinatairesencopie = $destinatairesencopie;
		$this->destinatairesencopiecachee = $destinatairesencopiecachee;
		$this->recherche = $recherche;
		
		/* Corrige les chanes des adresses mails */
		$destinataires = $this->destinataires();
		$this->destinataires = '';
		$i = 0;
		foreach ($destinataires as $destinataire) {
			if ($i == 0) {
				$this->destinataires .= $destinataire;
			} else {
				$this->destinataires .= ','.$destinataire;
			}
			$i++;		
		}
		$destinatairesencopie = $this->destinatairesencopie();
		$this->destinatairesencopie = '';
		$i = 0;
		foreach ($destinatairesencopie as $destinataireencopie) {
			if ($i == 0) {
				$this->destinatairesencopie .= $destinataireencopie;
			} else {
				$this->destinatairesencopie .= ','.$destinataireencopie;
			}
			$i++;		
		}
		$destinatairesencopiecachee = $this->destinatairesencopiecachee();
		$this->destinatairesencopiecachee = '';
		$i = 0;
		foreach ($destinatairesencopiecachee as $destinataireencopiecachee) {
			if ($i == 0) {
				$this->destinatairesencopiecachee .= $destinataireencopiecachee;
			} else {
				$this->destinatairesencopiecachee .= ','.$destinataireencopiecachee;
			}
			$i++;		
		}
	}
	
	/* Retourne tous les contacts de l'annuaire selon son type et les droits d'accs de l'utilisateur courant */
	/* Si $this->lettre est prcis, on retourne uniquement les contacts dont les noms dbutent par la lettre */
	function contacts() {
		if ($this->modeaffichage == 'annuaire') {
			/* On rcupre tous les contacts */
			/* liste tous les projets dont l'utilisateur courant est intervenant */
			$contacts = array();
			$idutilisateurs = array(); /* empche les doublons */
			$idclientutilisateurs = array(); /* ne supprime pas les doublons dans le cas o un utilisateur se trouve dans plusieurs clients */
			if ($this->idclient != '') {
				$projets = troubletickets_listeprojets('', $this->idclient);
			} else {
				$projets = troubletickets_listeprojets();
			}
			/* Liste des projets */
			$nbProjets = count($projets);
			for ($i=0;$i<=$nbProjets-1;$i++) {
				/* Test des droits intervenants */
				if ($projets[$i]->alesdroits('intervenants')) {
					$contactsprojet = $projets[$i]->contactsclients($this->lettre);
					$nbContactsProjets = count($contactsprojet);
					for ($j=0;$j<=$nbContactsProjets-1;$j++) {
						if (!in_array($contactsprojet[$j]->idutilisateur, $idutilisateurs)) {
							/* L'interlocuteur client n'a pas encore t ajout dans la liste, on l'ajoute */
							$contacts[] = $contactsprojet[$j];
							$idutilisateurs[] = $contactsprojet[$j]->idutilisateur;
							$idclientutilisateurs[] = array($contactsprojet[$j]->idclient);
						} else {
							/* Gre les utilisateurs faisant partie de plusieurs clients : l'interlocuteur client
							   a dj t ajout mais il peut faire partie d'un autre client */
							$index = array_search($contactsprojet[$j]->idutilisateur, $idutilisateurs);
							if (!in_array($contactsprojet[$j]->idclient, $idclientutilisateurs[$index])) {
								$contacts[] = $contactsprojet[$j];
								$idclientutilisateurs[$index][] = $contactsprojet[$j]->idclient;
							}
						}
					}
					$contactsprojet = $projets[$i]->contactsintervenants($this->lettre);
					$nbContactsProjets = count($contactsprojet);
					for ($j=0;$j<=$nbContactsProjets-1;$j++) {
						if (!in_array($contactsprojet[$j]->idutilisateur, $idutilisateurs)) {
							$contacts[] = $contactsprojet[$j];
							$idutilisateurs[] = $contactsprojet[$j]->idutilisateur;
							$idclientutilisateurs[] = array($contactsprojet[$j]->idclient);
						}
					}
					$contactsprojet = $projets[$i]->contactslecteurs($this->lettre);
					$nbContactsProjets = count($contactsprojet);
					for ($j=0;$j<=$nbContactsProjets-1;$j++) {
						if (!in_array($contactsprojet[$j]->idutilisateur, $idutilisateurs)) {
							$contacts[] = $contactsprojet[$j];
							$idutilisateurs[] = $contactsprojet[$j]->idutilisateur;
							$idclientutilisateurs[] = array($contactsprojet[$j]->idclient);
						}
					}
				}
			}
			return $contacts;
		}
		if ($this->modeaffichage == 'selectionauteurticket') {
			if ($this->idprojet != '') {
				/* On rcupre tous les contacts clients du projet */
				$projet = new TroubleTickets_Projet($this->idprojet);
				$projet->charge();
				return $projet->contactsclients($this->lettre);
			} else {
				/* On rcupre tous les contacts clients */
				/* liste tous les projets dont l'utilisateur courant est intervenant */
				$contacts = array();
				$idutilisateurs = array(); /* empche les doublons */
				$idclientutilisateurs = array(); /* ne supprime pas les doublons dans le cas o un utilisateur se trouve dans plusieurs clients */
				/* Gre le filtre sur l'id client : utilis dans l'tape 2 de cration d'un ticket par un intervenant aprs avoir slectionn un client */
				if ($this->idclient != '') {
					$projets = troubletickets_listeprojets('', $this->idclient);
				} else {
					$projets = troubletickets_listeprojets();
				}
				$nbProjets = count($projets);
				for ($i=0;$i<=$nbProjets-1;$i++) {
					if ($projets[$i]->alesdroits('intervenants')) {
						$contactsprojet = $projets[$i]->contactsclients($this->lettre);
						$nbContactsProjets = count($contactsprojet);
						for ($j=0;$j<=$nbContactsProjets-1;$j++) {
							if (!in_array($contactsprojet[$j]->idutilisateur, $idutilisateurs)) {
								$contacts[] = $contactsprojet[$j];
								$idutilisateurs[] = $contactsprojet[$j]->idutilisateur;
								$idclientutilisateurs[] = array($contactsprojet[$j]->idclient);
							} else {
								/* Gre les utilisateurs faisant partie de plusieurs clients */
								$index = array_search($contactsprojet[$j]->idutilisateur, $idutilisateurs);
								if (!in_array($contactsprojet[$j]->idclient, $idclientutilisateurs[$index])) {
									$contacts[] = $contactsprojet[$j];
									$idclientutilisateurs[$index][] = $contactsprojet[$j]->idclient;
								}
							}
						}
					}
				}
				return $contacts;
			}			
		}
		if ($this->modeaffichage == 'selectiondestinatairesmail') {
			/* On rcupre tous les contacts */
			/* liste tous les projets dont l'utilisateur courant est intervenant */
			$contacts = array();
			$idutilisateurs = array(); /* empche les doublons */
			$idclientutilisateurs = array(); /* ne supprime pas les doublons dans le cas o un utilisateur se trouve dans plusieurs clients */
			if ($this->idclient != '') {
				$projets = troubletickets_listeprojets('', $this->idclient);
			} else {
				$projets = troubletickets_listeprojets();
			}
			$nbProjets = count($projets);
			for ($i=0;$i<=$nbProjets-1;$i++) {
				if ($projets[$i]->alesdroits('intervenants')) {
					$contactsprojet = $projets[$i]->contactsclients($this->lettre);
					$nbContactsProjets = count($contactsprojet);
					for ($j=0;$j<=$nbContactsProjets-1;$j++) {
						if (!in_array($contactsprojet[$j]->idutilisateur, $idutilisateurs)) {
							$contacts[] = $contactsprojet[$j];
							$idutilisateurs[] = $contactsprojet[$j]->idutilisateur;
							$idclientutilisateurs[] = array($contactsprojet[$j]->idclient);
						} else {
							/* Gre les utilisateurs faisant partie de plusieurs clients */
							$index = array_search($contactsprojet[$j]->idutilisateur, $idutilisateurs);
							if (!in_array($contactsprojet[$j]->idclient, $idclientutilisateurs[$index])) {
								$contacts[] = $contactsprojet[$j];
								$idclientutilisateurs[$index][] = $contactsprojet[$j]->idclient;
							}
						}
					}
					$contactsprojet = $projets[$i]->contactsintervenants($this->lettre);
					$nbContactsProjets = count($contactsprojet);
					for ($j=0;$j<=$nbContactsProjets-1;$j++) {
						if (!in_array($contactsprojet[$j]->idutilisateur, $idutilisateurs)) {
							$contacts[] = $contactsprojet[$j];
							$idutilisateurs[] = $contactsprojet[$j]->idutilisateur;
							$idclientutilisateurs[] = array($contactsprojet[$j]->idclient);
						}
					}
					$contactsprojet = $projets[$i]->contactslecteurs($this->lettre);
					$nbContactsProjets = count($contactsprojet);
					for ($j=0;$j<=$nbContactsProjets-1;$j++) {
						if (!in_array($contactsprojet[$j]->idutilisateur, $idutilisateurs)) {
							$contacts[] = $contactsprojet[$j];
							$idutilisateurs[] = $contactsprojet[$j]->idutilisateur;
							$idclientutilisateurs[] = array($contactsprojet[$j]->idclient);
						}
					}
				}
			}
			return $contacts;
		}
	}
	
	/* Retourne un tableau avec les adresses mails des destinataires */
	function destinataires() {
		/* met en minuscules la chaine */
		$destinataires = strtolower($this->destinataires);
		/* remplace tous les espaces par des virgules afin de grer les adresses spares par des espaces */
		$destinataires = str_replace(" ", ",", $destinataires);		
		/* remplace les points virgules par des virgules */
		$destinataires = str_replace(";", ",", $destinataires);	
		/* spare les lments entre virgules */
		$tab = explode(",", $destinataires);
		/* supprime les lments vides du tableau */
		$tab2 = array();
		$nbTab = count($tab);
		for ($i=0;$i<=$nbTab-1;$i++) {
			if ($tab[$i] != '') {
				$tab2[] = $tab[$i];
			}
		}
		$tab = $tab2;
		/* valide si chaque lment est bien une adresse mail */
		$tab2 = array();
		$nbTab = count($tab);
		for ($i=0;$i<=$nbTab-1;$i++) {
			if (troubletickets_valideadressemail($tab[$i])) {
				$tab2[] = $tab[$i];
			}
		}
		$tab = $tab2;
		return $tab;
	}
	
	/* Retourne un tableau avec les adresses mails des destinataires en copie */
	function destinatairesencopie() {
		/* met en minuscules la chaine */
		$destinataires = strtolower($this->destinatairesencopie);
		/* remplace tous les espaces par des virgules afin de grer les adresses spares par des espaces */
		$destinataires = str_replace(" ", ",", $destinataires);		
		/* remplace les points virgules par des virgules */
		$destinataires = str_replace(";", ",", $destinataires);	
		/* spare les lments entre virgules */
		$tab = explode(",", $destinataires);
		/* supprime les lments vides du tableau */
		$tab2 = array();
		$nbTab = count($tab);
		for ($i=0;$i<=$nbTab-1;$i++) {
			if ($tab[$i] != '') {
				$tab2[] = $tab[$i];
			}
		}
		$tab = $tab2;
		/* valide si chaque lment est bien une adresse mail */
		$tab2 = array();
		$nbTab = count($tab);
		for ($i=0;$i<=$nbTab-1;$i++) {
			if (troubletickets_valideadressemail($tab[$i])) {
				$tab2[] = $tab[$i];
			}
		}
		$tab = $tab2;
		return $tab;
	}
	
	/* Retourne un tableau avec les adresses mails des destinataires en copie cache */
	function destinatairesencopiecachee() {
		/* met en minuscules la chaine */
		$destinataires = strtolower($this->destinatairesencopiecachee);
		/* remplace tous les espaces par des virgules afin de grer les adresses spares par des espaces */
		$destinataires = str_replace(" ", ",", $destinataires);		
		/* remplace les points virgules par des virgules */
		$destinataires = str_replace(";", ",", $destinataires);	
		/* spare les lments entre virgules */
		$tab = explode(",", $destinataires);
		/* supprime les lments vides du tableau */
		$tab2 = array();
		$nbTab = count($tab);
		for ($i=0;$i<=$nbTab-1;$i++) {
			if ($tab[$i] != '') {
				$tab2[] = $tab[$i];
			}
		}
		$tab = $tab2;
		/* valide si chaque lment est bien une adresse mail */
		$tab2 = array();
		$nbTab = count($tab);
		for ($i=0;$i<=$nbTab-1;$i++) {
			if (troubletickets_valideadressemail($tab[$i])) {
				$tab2[] = $tab[$i];
			}
		}
		$tab = $tab2;
		return $tab;
	}
}

