<?php
class TroubleTickets_Client {
	
	//Variables
	var $id;
	var $nom;
	var $description;

	//Constructeur
	function __construct($id='', $nom='', $description='') {
		$this->id = $id;
		$this->nom = $nom;
		$this->description = $description;
	}
	
	/* Charge les donnes enregistres dans la table de donnes dans l'objet */
	function charge() {
		$requete = "select `id`, `nom`, `description` from `".TROUBLETICKETS_CLIENT."` where id='".$this->id."'";
		$idrequete = 0;
		$erreurs = array();
		$res = troubletickets_sql($requete, $erreurs, $idrequete);
		if (count($res) == 1) {
			$this->id = $res[0]['id'];
			$this->nom = $res[0]['nom'];
			$this->description = $res[0]['description'];
		}
	}
	
	/* Enregistre les donnes du client */
	function enregistre() {
		/* Traite les problmes d'encodage :
		 * Lorsqu'on installe TroubleTickets sur un site en ISO-8859-15, si une personne renseigne du contenu contenant des caractres
		 * non ISO dans un textarea (par exemple un copier-coller d'Outlook, Excel... qui sont en encodage Windows-1252)
		 * le navigateur retourne des caractres en htmlentities (les apostrophes de Word sont renvoyes en &#8217;) */
		if (bab_Charset::getIso() !== bab_Charset::UTF_8 && function_exists('iconv')) {
			$this->description = @iconv(bab_Charset::getIso(), bab_Charset::UTF_8, $this->description);
			$this->description = html_entity_decode($this->description, ENT_QUOTES, bab_Charset::UTF_8);
			$this->description = @iconv(bab_Charset::UTF_8, bab_Charset::getIso() .'//TRANSLIT', $this->description);
		}
		
		if ($this->id == '') {
			/* On cr le nouveau client */
			$nom = $this->nom;
			$description = $this->description;
			troubletickets_echappesql($nom);
			troubletickets_echappesql($description);
			$requete = "insert into `".TROUBLETICKETS_CLIENT."` ( `id` , `nom` , `description` )
							  values ( '' , '$nom' , '$description' )
							";			
			$idrequete = 0;
			troubletickets_sql($requete, $erreurs, $idrequete);
			if (count($erreurs) == 0) {
				//On met  jour l'id
				$this->id = troubletickets_sqlid($idrequete);
				$erreurs[] = "Save done";
				return $this->id;
			}
		} else {
			/* On met  jour le client */
			$id = $this->id;
			$nom = $this->nom;
			$description = $this->description;
			troubletickets_echappesql($id);
			troubletickets_echappesql($nom);
			troubletickets_echappesql($description);
			$requete = "update `".TROUBLETICKETS_CLIENT."` set `nom`='".$nom."',`description`='".$description."' where id='".$id."'";
			troubletickets_sql($requete, $erreurs, $idrequete="");
			if (count($erreurs) == 0) {
				$erreurs[] = "Save done";
			}
			return $this->id;
		}
	}
	
	/* Renvoie la liste des projets du client */
	function projets() {
		return troubletickets_listeprojets('', $this->id);
	}
	
	/* Renvoie les interlocuteurs du client en objet TroubleTickets_ContactAnnuaire */
	function interlocuteurs() {
		$interlocuteurs = array();
		$idutilisateurs = array(); /* stocke les identifiants des utilisateurs pour viter les doublons */
		//On rcupre tous les utilisateurs qui ont des droits clients sur les projets du client
		//Liste des projets du client
		$projets = $this->projets();
		$nbProjets = count($projets);
		for ($i=0;$i<=$nbProjets-1;$i++) {
			$membres = troubletickets_membresdroit(TROUBLETICKETS_DROITSPROJETS_CLIENTS, $projets[$i]->id, true, false);
			$idmembres = array_keys($membres);//retourne les cls du tableau
			$nbIdMembres = count($idmembres);
			for ($k=0;$k<=$nbIdMembres-1;$k++) {
				if (!in_array($idmembres[$k], $idutilisateurs)) {
					$idutilisateurs[] = $idmembres[$k];
					$interlocuteurs[] = new TroubleTickets_ContactAnnuaire('', $idmembres[$k], $this->id, $membres[$idmembres[$k]]['lastname'], $membres[$idmembres[$k]]['firstname'], $membres[$idmembres[$k]]['email'], 'client', $this->nom);
				}
			}
		}
		return $interlocuteurs;
	}
	
	/* Supprime l'objet */
	function supprime() {
		if ($this->id != '') {
			/* Suppression des projets */
			$projets = $this->projets();
			for ($i=0;$i<=count($projets)-1;$i++) {
				$projets[$i]->supprime();
			}
			
			/* Suppression du client */
			$requete = "delete from `".TROUBLETICKETS_CLIENT."` where id='".$this->id."'";
			$idrequete = 0;
			$erreurs = array();
			$res = troubletickets_sql($requete, $erreurs, $idrequete);
		}
	}
	
}

