<?php
class TroubleTickets_Filtre {
	
	//Variables
	var $nom;
	var $valeur; /* Valeur aprs vrification des paramtres GET et POST. Si vide, valeur actuelle du cookie */
	var $valeuractuelle; /* Valeur actuelle dans le cookie */
	var $valeurpourfiltresactifs;
	var $actif;
	var $urlsupprimerfiltre;
	
	//Constructeur
	function __construct($nom='') {
		$this->nom = $nom;
		$this->valeuractuelle = troubletickets_valeurcookie('troubletickets_'.$this->nom); /* Valeur actuelle dans le cookie */
		$this->valeurpourfiltresactifs = '';
		$this->urlsupprimerfiltre = '#';
		/* Recherche de la valeur dsire par mthode get ou post */
		$parametres = array($this->nom);
		$resultats = troubletickets_recuperedonnees('', $parametres);
		$this->valeur = $resultats[$this->nom];
		/* Si on ne passe rien en paramtre, on utilise la valeur actuelle du cookie */
		if ($this->valeur == '') {
			$this->valeur = $this->valeuractuelle;
		}
		/* Si on reoit la valeur vide depuis le formulaire de recherche, c'est qu'on cherche  rinitialiser la valeur */
		if ($this->nom == 'filtrerecherche') {
			if ((bab_pp('filtrerecherche', 'pasderecherchedemandee') == '') || $this->valeur == 'pasderecherchedemandee') {
				$this->valeur = '';
			}
		}
		
		/* Si on reoit la valeur vide depuis les filtres sur statuts, c'est qu'on cherche  rinitialiser la valeur :
		   par dfaut on affiche le statut ouvert des tickets */
		if ($this->nom == 'filtrestatut') {
			if ($this->valeur == '') {
				$this->valeur = 'ouvert';
			}
		}
		
		/* Si on reoit la valeur vide depuis les filtres sur gravits, c'est qu'on cherche  rinitialiser la valeur :
		   par dfaut on affiche toutes les gravits de tickets */
		if ($this->nom == 'filtregravite') {
			if ($this->valeur == '') {
				$this->valeur = 'tous';
			}
		}
		
		/* Si on reoit la valeur vide depuis les filtres sur gravits, c'est qu'on cherche  rinitialiser la valeur :
		   par dfaut on affiche toutes les gravits de tickets */
		if ($this->nom == 'filtrecategoriecloture') {
			if ($this->valeur == '') {
				$this->valeur = 'tous';
			}
		}
		
		/* Gestion du multi-pages */
		if ($this->nom == 'pagecourante') {
			if ($this->valeur == '') {
				/* Affiche la premire page */
				$this->valeur = 1;
			}
		}
		if ($this->nom == 'nbticketsparpages') {
			/* On dfinit  50 tickets par page */
			if (!is_numeric($this->valeur)) {
				$this->valeur = 50;
			}
		}
		
		if ($this->valeur != '') {
			if ($this->valeur == 'tous') {
				$this->actif = false;
			} else {
				$this->actif = true;
			}
			/* Rcupre la valeur  afficher dans les filtres actifs selon le filtre */
			if ($this->actif) {
				switch($this->nom) {
					case 'filtreprojet':
						$projet = new TroubleTickets_Projet($this->valeur);
						$projet->charge();
						$this->valeurpourfiltresactifs = '<b>'.troubletickets_traduire('Project').' : </b>'.$projet->nom;
						global $babAddonUrl;
						$this->urlsupprimerfiltre = $babAddonUrl.'user&amp;idx=ticketsliste&amp;pagecourante=1&amp;filtreprojet=tous';
						break;
					case 'filtreclient':
						$client = new TroubleTickets_Client($this->valeur);
						$client->charge();
						$this->valeurpourfiltresactifs = '<b>'.troubletickets_traduire('Customer').' : </b>'.$client->nom;
						global $babAddonUrl;
						$this->urlsupprimerfiltre = $babAddonUrl.'user&amp;idx=ticketsliste&amp;pagecourante=1&amp;filtreclient=tous&amp;filtreinterlocuteur=tous';
						break;
					case 'filtrestatut':
						if ($this->valeur == 'ouvert') {
							$statut = troubletickets_traduire('Open tickets');
						} else {
							$statut = '';
							
							$statutstickets = troubletickets_listestatutstickets();
							$statutsechanges = troubletickets_listestatutsechanges();
							
							/* $filtrestatut contient un ou plusieurs identifiants de statuts */
							$filtrestatut = explode(",", $this->valeur);
							for ($i=0;$i<=count($filtrestatut)-1;$i++) {
								/* Supprime les espaces et les valeurs non numriques */
								$filtrestatut[$i] = trim($filtrestatut[$i]);
								if (is_numeric($filtrestatut[$i])) {
									/* On cherche le nom du statut */
									for ($j=0;$j<=count($statutstickets)-1;$j++) {
										if ($filtrestatut[$i] == $statutstickets[$j]['id']) {
											if ($statut == '') {
												$statut .= $statutstickets[$j]['nom'];
											} else {
												$statut .= ', '.$statutstickets[$j]['nom'];
											}
										}
									}
									for ($j=0;$j<=count($statutsechanges)-1;$j++) {
										if ($filtrestatut[$i] == $statutsechanges[$j]['id']) {
											if ($statut == '') {
												$statut .= $statutsechanges[$j]['nom'];
											} else {
												$statut .= ', '.$statutsechanges[$j]['nom'];
											}
										}
									}
								}
							}
							
							if ($statut == '') {
								$statut = 'filtre indfini';
							}
						}
						$this->valeurpourfiltresactifs = '<b>'.troubletickets_traduire('Statute').' : </b>'.$statut;
						global $babAddonUrl;
						$this->urlsupprimerfiltre = $babAddonUrl.'user&amp;idx=ticketsliste&amp;filtrestatut=tous';
						break;
					case 'filtregravite':
						$gravite = '';
							
						$gravitestickets = troubletickets_listegravites();
						
						/* $filtregravite contient un ou plusieurs identifiants de gravites */
						$filtregravite = explode(",", $this->valeur);
						for ($i=0;$i<=count($filtregravite)-1;$i++) {
							/* Supprime les espaces et les valeurs non numriques */
							$filtregravite[$i] = trim($filtregravite[$i]);
							if (is_numeric($filtregravite[$i])) {
								/* On cherche le nom de la gravite */
								for ($j=0;$j<=count($gravitestickets)-1;$j++) {
									if ($filtregravite[$i] == $gravitestickets[$j]['id']) {
										if ($gravite == '') {
											$gravite .= $gravitestickets[$j]['nom'];
										} else {
											$gravite .= ', '.$gravitestickets[$j]['nom'];
										}
									}
								}
							}
						}
						
						if ($gravite == '') {
							$gravite = 'filtre indfini';
						}
						
						$this->valeurpourfiltresactifs = '<b>'.troubletickets_traduire('Severity').' : </b>'.$gravite;
						global $babAddonUrl;
						$this->urlsupprimerfiltre = $babAddonUrl.'user&amp;idx=ticketsliste&amp;filtregravite=tous';
						break;
					case 'filtrecategoriecloture':
						$categoriecloture = '';
							
						$categoriescloturetickets = troubletickets_listcategoriesclotures();
						
						/* $filtregravite contient un ou plusieurs identifiants de gravites */
						$filtrecategoriecloture = explode(",", $this->valeur);
						for ($i=0;$i<=count($filtrecategoriecloture)-1;$i++) {
							/* Supprime les espaces et les valeurs non numriques */
							$filtrecategoriecloture[$i] = trim($filtrecategoriecloture[$i]);
							if (is_numeric($filtrecategoriecloture[$i])) {
								/* On cherche le nom de la gravite */
								for ($j=0;$j<=count($categoriescloturetickets)-1;$j++) {
									if ($filtrecategoriecloture[$i] == $categoriescloturetickets[$j]['id']) {
										if ($categoriecloture == '') {
											$categoriecloture .= $categoriescloturetickets[$j]['nom'];
										} else {
											$categoriecloture .= ', '.$categoriescloturetickets[$j]['nom'];
										}
									}
								}
							}
						}
						
						if ($categoriecloture == '') {
							$categoriecloture = 'filtre indfini';
						}
						
						$this->valeurpourfiltresactifs = '<b>'.troubletickets_traduire('Categorie de clture').' : </b>'.$categoriecloture;
						global $babAddonUrl;
						$this->urlsupprimerfiltre = $babAddonUrl.'user&amp;idx=ticketsliste&amp;filtrecategoriecloture=tous';
						break;
					case 'filtreniveauintervenants':
						$niveautab = new TroubleTickets_NiveauIntervenants($this->valeur);
						$niveautab->charge();
						$niveau = $niveautab->nom;
						$this->valeurpourfiltresactifs = '<b>'.troubletickets_traduire('Level').' : </b>'.$niveau;
						global $babAddonUrl;
						$this->urlsupprimerfiltre = $babAddonUrl.'user&amp;idx=ticketsliste&amp;filtreniveauintervenants=tous';
						break;
					case 'filtredernierintervenant':
						$nomintervenant = '';
						if (is_numeric($this->valeur)) {
							$ficheannuaire = troubletickets_ficheannuaire($this->valeur);
							$nomintervenant = $ficheannuaire['givenname'].' '.$ficheannuaire['sn'];
						}
						$this->valeurpourfiltresactifs = '<b>'.troubletickets_traduire('Speaker').' : </b>'.$nomintervenant;
						global $babAddonUrl;
						$this->urlsupprimerfiltre = $babAddonUrl.'user&amp;idx=ticketsliste&amp;filtredernierintervenant=tous';
						break;
					case 'filtreinterlocuteur':
						$interlocuteur = new TroubleTickets_ContactAnnuaire('', $this->valeur, '' ,'', '', '', 'client', '');
						$this->valeurpourfiltresactifs = '<b>'.troubletickets_traduire('Interlocutor').' : </b>'.$interlocuteur->nom().' '.$interlocuteur->prenom();
						global $babAddonUrl;
						$this->urlsupprimerfiltre = $babAddonUrl.'user&amp;idx=ticketsliste&amp;filtreinterlocuteur=tous';
						break;
					case 'filtrerecherche':
						$this->valeurpourfiltresactifs = '<b>'.troubletickets_traduire('Search').' : </b>'.$this->valeur;
						global $babAddonUrl;
						$this->urlsupprimerfiltre = $babAddonUrl.'user&amp;idx=ticketsliste&amp;filtrerecherche=pasderecherchedemandee';
						break;
					default:
						$this->valeurpourfiltresactifs = 'filtre indfini';
						break;
				}
			}
		} else {
			$this->actif = false;
		}
	}
	
	/* Enregistre le filtre en cookie */
	function enregistre() {
		/* Enregistre le cookie si modification demande */
		if ($this->valeuractuelle != $this->valeur) {
			/* Si le filtre vaut 'tous', on supprime le filtre actuel : sauf pour filtrestatut et filtregravite */
			if ($this->valeur == 'tous') { /* Mise  vide du cookie car pas de filtre */
				if ($this->nom == 'filtrestatut' || $this->nom == 'filtregravite' || $this->nom == 'filtrecategoriecloture') {
					$filtre = $this->valeur;
					troubletickets_creecookie('troubletickets_'.$this->nom, $filtre);
				} else {
					$filtre = '';
					troubletickets_creecookie('troubletickets_'.$this->nom, $filtre);
					$this->valeur = $filtre;
				}
			} else {
				$filtre = $this->valeur;
				troubletickets_creecookie('troubletickets_'.$this->nom, $filtre);
			}
		}		
	}
	
}

?>
