<?php
class TroubleTickets_Projet {
	
	var $id;
	var $nom;
	var $type; /* 1 : Contrat de support ; 2 : Contrat spcifique ; 3 : Projet */
	var $client;
	var $statut; /* 1 : ouvert ; 2 : ferm */
	var $auteur;
	var $notifiertouslesinterlocuteurs; /* Si vaut 1 : on notifie tous les interlocuteurs clients. Si vaut 2, uniquement l'auteur du ticket */
	var $droitsdaccesdesinterlocuteurssurlesticketsdesautresauteurs; /* nevoitquelesticketsdontilestauteur : Un interlocuteur ne voit que les tickets dont il est l'auteur, interlocuteurpeutvoirlesticketsdesautres : Un interlocuteur peut voir les tickets des autres auteurs, cette option n'a pas d'effets sur les utilisateurs qui ont uniquement le droit d'accs lecturetickets */
	
	//Constructeur
	function __construct($id='', $nom='', $type='', $idclient='', $statut='', $auteur='', $notifiertouslesinterlocuteurs='', $droitsdaccesdesinterlocuteurssurlesticketsdesautresauteurs='') {
		$this->id = $id;
		$this->nom = $nom;
		$this->type = $type;
		if ($this->type != 1 && $this->type != 2 && $this->type != 3) {
			$this->type = 1;
		}
		$this->client = $idclient;
		$this->statut = $statut;
		if ($this->statut != 1 && $this->statut != 2) {
			$this->statut = 1;
		}
		$this->auteur = $auteur;
		if ($notifiertouslesinterlocuteurs != 1 && $notifiertouslesinterlocuteurs != 2) {
			$notifiertouslesinterlocuteurs = 1;
		}
		$this->notifiertouslesinterlocuteurs = $notifiertouslesinterlocuteurs;
		if ($droitsdaccesdesinterlocuteurssurlesticketsdesautresauteurs != 'nevoitquelesticketsdontilestauteur') {
			$droitsdaccesdesinterlocuteurssurlesticketsdesautresauteurs = 'interlocuteurpeutvoirlesticketsdesautres';
		}
		$this->droitsdaccesdesinterlocuteurssurlesticketsdesautresauteurs = $droitsdaccesdesinterlocuteurssurlesticketsdesautresauteurs;
	}
	
	/* Charge les donnes enregistres dans la table de donnes dans l'objet */
	function charge() {
		$requete = "select `id`, `nom`, `type`, `client`, `statut`, `auteur`, `notifiertouslesinterlocuteurs`, `droitsdaccesdesinterlocuteurssurlesticketsdesautresauteurs` from `".TROUBLETICKETS_PROJET."` where id='".$this->id."'";
		$idrequete = 0;
		$erreurs = array();
		$res = troubletickets_sql($requete, $erreurs, $idrequete);
		if (count($res) == 1) {
			$this->nom = $res[0]['nom'];
			$this->type = $res[0]['type'];
			$this->client = $res[0]['client'];
			$this->statut = $res[0]['statut'];
			$this->auteur = $res[0]['auteur'];
			if ($res[0]['notifiertouslesinterlocuteurs'] != 1 && $res[0]['notifiertouslesinterlocuteurs'] != 2) {
				$res[0]['notifiertouslesinterlocuteurs'] = 1;
			}
			if ($res[0]['droitsdaccesdesinterlocuteurssurlesticketsdesautresauteurs'] != 'nevoitquelesticketsdontilestauteur') {
				$res[0]['droitsdaccesdesinterlocuteurssurlesticketsdesautresauteurs'] = 'interlocuteurpeutvoirlesticketsdesautres';
			}
			$this->notifiertouslesintervenants = $res[0]['notifiertouslesinterlocuteurs'];
			$this->droitsdaccesdesinterlocuteurssurlesticketsdesautresauteurs = $res[0]['droitsdaccesdesinterlocuteurssurlesticketsdesautresauteurs'];
		}
	}
	
	/* Vrifie si l'utilisateur courant a des droits d'accs dans le projet
	 * Type de droits :
	 * clients : client, droits de dpots, d'echanges et droits de lecture
	 * lecturetickets : droit de lecture des tickets
	 * intervenants : intervenant, peut dposer des tickets, changer et a des droits de lecture
	 * mailsnouveauxtickets : notifi de nouveaux tickets crs par les clients
	 * mailsnouveauxticketsintervenants : notifi de nouveaux tickets crs par les intervenants
	 * mailsechangesclients : notifi des changes du client
	 * mailsechangesintervenants : notifi des changes de l'intervenant
	 */
	function alesdroits($droit='') {
		if ($droit != '') {
			$table = '';
			switch(strtolower($droit)) {
				case 'clients':
					$table = TROUBLETICKETS_DROITSPROJETS_CLIENTS;
					break;
				case 'lecturetickets':
					$table = TROUBLETICKETS_DROITSPROJETS_LECTURETICKETS;
					break;
				case 'intervenants':
					$table = TROUBLETICKETS_DROITSPROJETS_INTERVENANTS;
					break;
				case 'mailsnouveauxticketsclients':
					$table = TROUBLETICKETS_DROITSPROJETS_MAILSNOUVEAUXTICKETS;
					break;
				case 'mailsnouveauxticketsintervenants':
					$table = TROUBLETICKETS_DROITSPROJETS_MAILSNOUVEAUXTICKETSINTERVENANTS;
					break;
				case 'mailsechangesclients':
					$table = TROUBLETICKETS_DROITSPROJETS_MAILSECHANGESCLIENTS;
					break;
				case 'mailsechangesintervenants':
					$table = TROUBLETICKETS_DROITSPROJETS_MAILSECHANGESINTERVENANTS;
					break;
				default:
					return false;
					break;
			}
			if (troubletickets_verifieacl($this->id, $table)) {
				return true;
			}
		} else {
			if (troubletickets_verifieacl($this->id, TROUBLETICKETS_DROITSPROJETS_CLIENTS)) {
				return true;
			}
			if (troubletickets_verifieacl($this->id, TROUBLETICKETS_DROITSPROJETS_LECTURETICKETS)) {
				return true;
			}
			if (troubletickets_verifieacl($this->id, TROUBLETICKETS_DROITSPROJETS_INTERVENANTS)) {
				return true;
			}
			if (troubletickets_verifieacl($this->id, TROUBLETICKETS_DROITSPROJETS_MAILSNOUVEAUXTICKETS)) {
				return true;
			}
			if (troubletickets_verifieacl($this->id, TROUBLETICKETS_DROITSPROJETS_MAILSNOUVEAUXTICKETSINTERVENANTS)) {
				return true;
			}
			if (troubletickets_verifieacl($this->id, TROUBLETICKETS_DROITSPROJETS_MAILSECHANGESCLIENTS)) {
				return true;
			}
			if (troubletickets_verifieacl($this->id, TROUBLETICKETS_DROITSPROJETS_MAILSECHANGESINTERVENANTS)) {
				return true;
			}
		}
		return false;
	}
	
	/* Renvoit le client en objet TroubleTickets_Client */
	function client() {
		return troubletickets_listeclients($this->client);
	}
	
	/* Renvoit la liste des types d'un projet' */
	function types($type='') {
		if ($type != '') {
			switch($type) {
				case '1':
					return array('id' => '1', 'nom' => troubletickets_traduire('Contract of support'));
					break;
				case '2':
					return array('id' => '2', 'nom' => troubletickets_traduire('Specific contract'));
					break;
				case '3':
					return array('id' => '3', 'nom' => troubletickets_traduire('Project'));
					break;
			}
			return array();
		} else {
			$tab = array();
			$tab[] = array('id' => '1', 'nom' => troubletickets_traduire('Contract of support'));
			$tab[] = array('id' => '2', 'nom' => troubletickets_traduire('Specific contract'));
			$tab[] = array('id' => '3', 'nom' => troubletickets_traduire('Project'));
			return $tab;
		}
	}
	
	/* Renvoit la liste des statuts d'un projet' */
	function statuts($statut='') {
		if ($statut != '') {
			switch($statut) {
				case '1':
					return array('id' => '1', 'nom' => troubletickets_traduire('Open'));
					break;
				case '2':
					return array('id' => '2', 'nom' => troubletickets_traduire('Closed'));
					break;
			}
			return array();
		} else {
			$tab = array();
			$tab[] = array('id' => '1', 'nom' => troubletickets_traduire('Open'));
			$tab[] = array('id' => '2', 'nom' => troubletickets_traduire('Closed'));
			return $tab;
		}
	}
	
	/* Enregistre les donnes du projet */
	function enregistre() {
		if ($this->id == '') {
			/* On cr le nouveau projet */
			$nom = $this->nom;
			$type = $this->type;
			$client = $this->client;
			$statut = $this->statut;
			$auteur = $this->auteur;
			$notifiertouslesinterlocuteurs = $this->notifiertouslesinterlocuteurs;
			$droitsdaccesdesinterlocuteurssurlesticketsdesautresauteurs = $this->droitsdaccesdesinterlocuteurssurlesticketsdesautresauteurs;
			troubletickets_echappesql($nom);
			troubletickets_echappesql($type);
			troubletickets_echappesql($client);
			troubletickets_echappesql($statut);
			troubletickets_echappesql($auteur);
			troubletickets_echappesql($notifiertouslesinterlocuteurs);
			if ($notifiertouslesinterlocuteurs != 1 && $notifiertouslesinterlocuteurs != 2) {
				$notifiertouslesinterlocuteurs = 1;
			}
			if ($droitsdaccesdesinterlocuteurssurlesticketsdesautresauteurs != 'nevoitquelesticketsdontilestauteur') {
				$droitsdaccesdesinterlocuteurssurlesticketsdesautresauteurs = 'interlocuteurpeutvoirlesticketsdesautres';
			}			
			$requete = "insert into `".TROUBLETICKETS_PROJET."` ( `id` , `nom` , `type` , `client` , `statut` , `auteur`, `notifiertouslesinterlocuteurs`, `droitsdaccesdesinterlocuteurssurlesticketsdesautresauteurs` )
							  values ( '' , '$nom' , '$type' , '$client' , '$statut' , '$auteur' , '$notifiertouslesinterlocuteurs', '$droitsdaccesdesinterlocuteurssurlesticketsdesautresauteurs' )
							";
			$idrequete = 0;
			troubletickets_sql($requete, $erreurs, $idrequete);
			if (count($erreurs) == 0) {
				//On met  jour l'id
				$this->id = troubletickets_sqlid($idrequete);
				$erreurs[] = "Save done";
				return $this->id;
			}
		} else {
			/* On met  jour le projet */
			$id = $this->id;
			$nom = $this->nom;
			$type = $this->type;
			$client = $this->client;
			$statut = $this->statut;
			$auteur = $this->auteur;
			$notifiertouslesinterlocuteurs = $this->notifiertouslesinterlocuteurs;
			$droitsdaccesdesinterlocuteurssurlesticketsdesautresauteurs = $this->droitsdaccesdesinterlocuteurssurlesticketsdesautresauteurs;
			troubletickets_echappesql($nom);
			troubletickets_echappesql($type);
			troubletickets_echappesql($client);
			troubletickets_echappesql($statut);
			troubletickets_echappesql($auteur);
			troubletickets_echappesql($notifiertouslesinterlocuteurs);
			troubletickets_echappesql($droitsdaccesdesinterlocuteurssurlesticketsdesautresauteurs);
			$requete = "update `".TROUBLETICKETS_PROJET."` set `nom`='".$nom."',`type`='".$type."',`client`='".$client."',`statut`='".$statut."',`auteur`='".$auteur."',`notifiertouslesinterlocuteurs`='".$notifiertouslesinterlocuteurs."',`droitsdaccesdesinterlocuteurssurlesticketsdesautresauteurs`='".$droitsdaccesdesinterlocuteurssurlesticketsdesautresauteurs."' where id='".$id."'";
			troubletickets_sql($requete, $erreurs, $idrequete="");
			if (count($erreurs) == 0) {
				$erreurs[] = "Save done";
			}
			return $this->id;
		}
	}
	
	/* Renvoie le nombre de tickets du projet en rapport au statut.
	 * Peut tenir compte de l'option sur le projet "droits d'acces des interlocuteurs sur les tickets des autres auteurs"
	 * Le filtre est actif uniquement si l'utilisateur est un interlocuteur client !
	 * un intervenant doit continuer  voir les tickets des autres interlocuteurs
	 */
	function nbtickets($statut='', $tientCompteDesDroitsDAccesDesInterlocuteursSurLesTicketsDesAutresAuteurs=false) {
		/* Statuts d'un ticket : 1(en attente de prise en compte),2 (en cours de traitement),5 (demande de cloture),6,7,8,9 (ticket ferm) ; 3 (demande d'infos) et 4 (infos complmentaires) sont des statuts d'changes */
		
		$filtreAuteurSql = '';
		$filtreAuteur = '';
		/* On vrifie l'option sur les droits d'accs pour savoir si on filtre les tickets sur l'auteur (utilisateur en cours) */
		if ($tientCompteDesDroitsDAccesDesInterlocuteursSurLesTicketsDesAutresAuteurs && $this->droitsdaccesdesinterlocuteurssurlesticketsdesautresauteurs == 'nevoitquelesticketsdontilestauteur') {
			/* On vrifie si l'utilisateur en cours est client uniquement */
			if (troubletickets_adroitsprojets('clients', $this->id) && !troubletickets_adroitsprojets('intervenants', $this->id)) {
				$idUtilisateurCourant = troubletickets_idusercourant();
				$filtreAuteurSql = ' and `auteur`=\''.$idUtilisateurCourant.'\'';
				$filtreAuteur = $idUtilisateurCourant;
			}
		}
		
		if ($statut != 3 && $statut != 4) {
			/* Statut de tickets */
			$requete = "select `id` from `".TROUBLETICKETS_TICKET."` where `projet`='".$this->id."'";
			if ($statut != '') {
				$requete .= " and statutticket='$statut'";		
			}
			$requete .= $filtreAuteurSql;
			$idrequete = 0;
			$erreurs = array();
			$res = troubletickets_sql($requete, $erreurs, $idrequete);
			return count($res);
		} else {
			/* Statut d'changes */
			$tickets = $this->tickets(true);
			$total = 0;
			$nbtickets = count($tickets);
			for ($i=0;$i<=$nbtickets-1;$i++) {
				if ($filtreAuteur == '') {
					if ($statut == 3 && $tickets[$i]->dernierstatutechanges() == 3) {
						$total++;
					}
					if ($statut == 4 && $tickets[$i]->dernierstatutechanges() == 4) {
						$total++;
					}
				} else {
					/* Filtre sur les droits d'accs */
					if ($tickets[$i]->auteur == $filtreAuteur) {
						if ($statut == 3 && $tickets[$i]->dernierstatutechanges() == 3) {
							$total++;
						}
						if ($statut == 4 && $tickets[$i]->dernierstatutechanges() == 4) {
							$total++;
						}
					}
				}
			}
			return $total;
		}		
	}
	
	/* Retourne tous les contacts ayant le droit clients sur le projet
	   Retourne un tableau d'objets TroubleTickets_ContactAnnuaire */
	function contactsclients($lettre='') {
		/* Rcupre le nom du client */
		$client = new TroubleTickets_Client($this->client);
		$client->charge();
		
		$clients = array();
		$membres = troubletickets_membresdroit(TROUBLETICKETS_DROITSPROJETS_CLIENTS, $this->id, true, false);
		$idutilisateurs = array_keys($membres); //retourne les cls du tableau
		$nbIdUtilisateurs = count($idutilisateurs);
		for ($i=0;$i<=$nbIdUtilisateurs-1;$i++) {
			if ($lettre == '') {
				$clients[] = new TroubleTickets_ContactAnnuaire('', $idutilisateurs[$i], $this->client, $membres[$idutilisateurs[$i]]['lastname'], $membres[$idutilisateurs[$i]]['firstname'], $membres[$idutilisateurs[$i]]['email'], 'client', $client->nom);
			} else {
				if (strlen($membres[$idutilisateurs[$i]]['lastname']) >= 1) {
					if (substr($membres[$idutilisateurs[$i]]['lastname'],0,1) == strtoupper($lettre) || substr($membres[$idutilisateurs[$i]]['lastname'],0,1) == strtolower($lettre)) {
						$clients[] = new TroubleTickets_ContactAnnuaire('', $idutilisateurs[$i], $this->client, $membres[$idutilisateurs[$i]]['lastname'], $membres[$idutilisateurs[$i]]['firstname'], $membres[$idutilisateurs[$i]]['email'], 'client', $client->nom);
					}
				}
			}
		}
		return $clients;
	}
	
	/* Retourne tous les contacts ayant le droit intervenants sur le projet
	   Retourne un tableau d'objets TroubleTickets_ContactAnnuaire */
	function contactsintervenants($lettre='') {
		$intervenants = array();
		$membres = troubletickets_membresdroit(TROUBLETICKETS_DROITSPROJETS_INTERVENANTS, $this->id, true, false);
		$idutilisateurs = array_keys($membres); //retourne les cls du tableau
		$nbIdUtilisateurs = count($idutilisateurs);
		for ($i=0;$i<=$nbIdUtilisateurs-1;$i++) {
			if ($lettre == '') {
				$intervenants[] = new TroubleTickets_ContactAnnuaire('', $idutilisateurs[$i], '', $membres[$idutilisateurs[$i]]['lastname'], $membres[$idutilisateurs[$i]]['firstname'], $membres[$idutilisateurs[$i]]['email'], 'intervenant', '');
			} else {
				if (strlen($membres[$idutilisateurs[$i]]['lastname']) >= 1) {
					if (substr($membres[$idutilisateurs[$i]]['lastname'],0,1) == strtoupper($lettre) || substr($membres[$idutilisateurs[$i]]['lastname'],0,1) == strtolower($lettre)) {
						$intervenants[] = new TroubleTickets_ContactAnnuaire('', $idutilisateurs[$i], '', $membres[$idutilisateurs[$i]]['lastname'], $membres[$idutilisateurs[$i]]['firstname'], $membres[$idutilisateurs[$i]]['email'], 'intervenant', '');
					}
				}
			}
		}
		return $intervenants;
	}
	
	/* Retourne tous les contacts ayant le droit lecture sur le projet
	   Retourne un tableau d'objets TroubleTickets_ContactAnnuaire */
	function contactslecteurs($lettre='') {
		$lecteurs = array();
		$membres = troubletickets_membresdroit(TROUBLETICKETS_DROITSPROJETS_LECTURETICKETS, $this->id, true, false);
		$idutilisateurs = array_keys($membres); //retourne les cls du tableau
		$nbIdUtilisateurs = count($idutilisateurs);
		for ($i=0;$i<=$nbIdUtilisateurs-1;$i++) {
			if ($lettre == '') {
				$lecteurs[] = new TroubleTickets_ContactAnnuaire('', $idutilisateurs[$i], '', $membres[$idutilisateurs[$i]]['lastname'], $membres[$idutilisateurs[$i]]['firstname'], $membres[$idutilisateurs[$i]]['email'], 'lecteur', '');
			} else {
				if (strlen($membres[$idutilisateurs[$i]]['lastname']) >= 1) {
					if (substr($membres[$idutilisateurs[$i]]['lastname'],0,1) == strtoupper($lettre) || substr($membres[$idutilisateurs[$i]]['lastname'],0,1) == strtolower($lettre)) {
						$lecteurs[] = new TroubleTickets_ContactAnnuaire('', $idutilisateurs[$i], '', $membres[$idutilisateurs[$i]]['lastname'], $membres[$idutilisateurs[$i]]['firstname'], $membres[$idutilisateurs[$i]]['email'], 'lecteur', '');
					}
				}
			}
		}
		return $lecteurs;
	}
	
	/* Retourne la liste des tickets d'un projet en objet TroubleTickets_Ticket */
	function tickets($count = false) {		
		$tickets = array();
		$requete = "select `id`, `projet`, `reference`, `auteur`, `titre`, `description`, `statutticket`, `gravite`, `dateticket`, `ticketcreeparintervenant`, `niveauintervenants`, `dernierintervenant`, `statutechange`, `datederniereoperation` from `".TROUBLETICKETS_TICKET."` where projet='".$this->id."' ";
		if($count){
			$requete.= " and statutticket IN('1','2','7') ";
		}
		$requete.= " order by id asc";	
		
		$idrequete = 0;
		$erreurs = array();
		$res = troubletickets_sql($requete, $erreurs, $idrequete);
		if (count($res) != 0) {
			//Construction des objets Tickets
			$nb = count($res);
			for ($i=0;$i<=$nb-1;$i++) {
				if ($res[$i]['ticketcreeparintervenant'] == 2) {
					$res[$i]['ticketcreeparintervenant'] = true;
				} else {
					$res[$i]['ticketcreeparintervenant'] = false;
				}
				if ($res[$i]['dernierintervenant'] === 0) {
					$res[$i]['dernierintervenant'] = '';
				}
				$tickets[] = new TroubleTickets_Ticket($res[$i]['id'], $res[$i]['projet'], $res[$i]['reference'], $res[$i]['auteur'], $res[$i]['titre'], $res[$i]['description'], $res[$i]['statutticket'], $res[$i]['gravite'], $res[$i]['dateticket'], $res[$i]['ticketcreeparintervenant'], $res[$i]['niveauintervenants'], $res[$i]['dernierintervenant'], $res[$i]['statutechange'], $res[$i]['datederniereoperation']);
			}
		}
		return $tickets;
	}
	
	/* Supprime l'objet */
	function supprime() {
		if ($this->id != '') {
			/* Suppression des tickets */
			$tickets = $this->tickets();
			for ($i=0;$i<=count($tickets)-1;$i++) {
				$tickets[$i]->supprime();
			}
			
			/* Suppression des droits sur le projet */
			troubletickets_supprimeACL($this->id, TROUBLETICKETS_DROITSPROJETS_CLIENTS);
			troubletickets_supprimeACL($this->id, TROUBLETICKETS_DROITSPROJETS_INTERVENANTS);
			troubletickets_supprimeACL($this->id, TROUBLETICKETS_DROITSPROJETS_LECTURETICKETS);
			troubletickets_supprimeACL($this->id, TROUBLETICKETS_DROITSPROJETS_MAILSECHANGESCLIENTS);
			troubletickets_supprimeACL($this->id, TROUBLETICKETS_DROITSPROJETS_MAILSECHANGESINTERVENANTS);
			troubletickets_supprimeACL($this->id, TROUBLETICKETS_DROITSPROJETS_MAILSHISTORIQUECLIENTS);
			troubletickets_supprimeACL($this->id, TROUBLETICKETS_DROITSPROJETS_MAILSHISTORIQUEINTERVENANTS);
			troubletickets_supprimeACL($this->id, TROUBLETICKETS_DROITSPROJETS_MAILSNOUVEAUXTICKETS);
			troubletickets_supprimeACL($this->id, TROUBLETICKETS_DROITSPROJETS_MAILSNOUVEAUXTICKETSINTERVENANTS);
			
			/* Suppression du projet */
			$requete = "delete from `".TROUBLETICKETS_PROJET."` where id='".$this->id."'";
			$idrequete = 0;
			$erreurs = array();
			$res = troubletickets_sql($requete, $erreurs, $idrequete);
		}
	}

}
